#include "Project.h"



/// STANDARD FEATURES
///
int   puppet          = -1;
float anims[16]       = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };

Camera2D camera       = { 0 };
Vector2 mouse         = { 0, 0 };
Vector2 mouse_cam     = { 0, 0 };


const char *main_options[] = {
 /* 00 */ "START GAME",
 /* 01 */ "TUTORIAL",
 /* 02 */ "EXIT",
 /* 03 */ "...",
 /* 04 */ "...",
 /* 05 */ "...",
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "..."
};



const char *summary_headers[] = {
 /* 00 */ "G A M E   O V E R",
 /* 01 */ "FINAL SCORE",
 /* 02 */ "...",
 /* 03 */ "...",
 /* 04 */ "...",
};


const char *summary_items[] = {
 /* 00 */ "CONTAINERS LAUNCHED",
 /* 01 */ "ENEMIES SHOT",
 /* 02 */ "ENEMIES ESCAPED",
 /* 03 */ "YO BLOCKS SHOT",
 /* 04 */ "...",
 /* 05 */ "...",
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "..."
};


const char *summary_units[] = {
 /* 00 */ "",
 /* 01 */ "",
 /* 02 */ "",
 /* 03 */ "",
 /* 04 */ "",
 /* 05 */ "...",
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "..."
};


const char *menu_keyboard_tips[] = {
 /* 00 */ "ARROWS/WASD - MOVE         Z - SELECT",
 /* 01 */ "J/K - JOYSTICK/KEYBOARD"
};

const char *menu_gamepad_tips[] = {
 /* 00 */ "ANALOG STICK 1 - MOVE      Z - SELECT",
 /* 01 */ "J/K - JOYSTICK/KEYBOARD"
};

const char *game_keyboard_tips[] = {
 /* 00 */ "ARROWS/WASD - MOVE",
 /* 01 */ "Z - FIRE      X - FLIP"
};

const char *game_gamepad_tips[] = {
 /* 00 */ "ANALOG STICK 1 - MOVE",
 /* 01 */ "TOP BUTTON - FIRE       LEFT BUTTON - FLIP"
};


/// SHADERS
///
// Shader crap here (plz move this into something sane FFS)
//
Shader scroll;
float scroll_vars[4] = { 0.0, 0.0, 0.0, 0.0 }; // Two sets of x/y offsets
int off_xLoc   = 0;
int off_yLoc   = 0;

Shader mosaic;
float m_var = 0.0;
int mos_mLoc;
int mos_aLoc;

Shader wave;
float s_vars[6] = {  4.0,  0.0,  4.0, 0.0,  2.0,  0.0 };  // Brush sine wave
float l_vars[6] = {  3.0,  2.0,  6.0, 8.0,  3.0,  2.5 };  // Title emoji
float k_vars[6] = {  6.0, 00.0, 32.0, 0.0,  1.0,  0.0 };  // Kelp sine wave
float h_vars[6] = { 10.0, 00.0, 64.0, 0.0,  2.0,  0.0 };  // Hook sine wave
float f_vars[6] = { 10.0, 10.0,  4.0, 4.0, 18.0, 18.0 };  // Fire sine wave
int secondsLoc = 0;
int freqXLoc   = 0;
int freqYLoc   = 0;
int ampXLoc    = 0;
int ampYLoc    = 0;
int speedXLoc  = 0;
int speedYLoc  = 0;

int loc_time     = 0;
int loc_strength = 0;
float seconds    = 0.0f;
float strength   = 0.0005f;

Shader crt;



/// PROJECT-SPECIFIC
///

Color colorset[16] = { BLANK, CHILL_CYAN, ORANGE, LIME, BROWN, WHITE, BLANK, BLANK,
                       BLANK, BLANK, PINK, PINK, PINK, BLANK, BLANK, BLANK };






#ifdef USE_TEXTBOX
    textbox_struct textbox[MAX_TEXTBOX];

    float box_tex_x = 0;              // For anchoring happy texture at game over summary
    float box_tex_y = 0;              //
    int box_update  = 0;              //

    const char *textbox_messages[] = {
 /* 00 */ ".",
 /* 01 */ "USE THE ARROW KEYS, WASD, OR A GAMEPAD TO MOVE",
 /* 02 */ "PRESS PRIMARY BUTTON TO FIRE",
 /* 03 */ "PRESS SECONDARY BUTTON TO FLIP ROCKET",
 /* 04 */ "SHOOT ENEMIES AND FILL BINS WITH SAND TO SCORE",
 /* 05 */ "EACH BIN HAS A SINGLE COLOR. PAY ATTENTION",
 /* 06 */ "SHOOT YO! BLOCKS TO ERASE BUILDUP AND DIRT",
 /* 07 */ "AVOID BROWN BOMBERS. THEY DROP DIRT",
 /* 08 */ "GAME ENDS WHEN ALL BINS ARE COVERED UP WITH SAND",
 /* 09 */ "END OF TUTORIAL. PRESS ESC TO RETURN TO MENU",

 /* 10 */ ".",
 /* 11 */ ".",
 /* 12 */ ".",
 /* 13 */ ".",
 /* 14 */ ".",
 /* 15 */ ".",
 /* 16 */ ".",
 /* 17 */ ".",
 /* 18 */ ".",
 /* 19 */ "."
    };

#endif



#ifdef USE_BULLETIN
    bulletin_struct bulletin;

    const char *bulletins[] = {
 /* 00 */ "LEAVE BLANK",
 /* 01 */ "...",
 /* 02 */ "...",
 /* 03 */ "...",
 /* 04 */ "...",
 /* 05 */ "TOP SCORE: 00000666 BY GDR                            ", // Don't modify this string (used by High score)
 /* 06 */ "...",
 /* 07 */ "...",
 /* 08 */ "...",
 /* 09 */ "..."
    };
#endif // USE_BULLETIN






