#include "Project.h"



// Only called by field update routine
//
void update_left_first(int x, int y, int p);
void update_right_first(int x, int y, int p);



// Draws containers as well as any pixels filling them
//
void draw_containers()
{
 int i = 0;
 int j = 0;
 int k = 0;
 int start_y = SCREEN_H - (FIELD_Y * 6);
 int start_by = FIELD_Y - 28;
 int start_bx = 0;

 Vector2 pos = { 0 };

 // I could do this procedurally, but I'm feeling *very* lazy right now
 // Just blit outline of container
 //
 for(i=0; i<3; i++) {
     pos.x = (((FIELD_X / 4) * 6) * (i+1)) - (7 * 6);
     pos.y = start_y + (FIELD_Y * 6) - (28 * 6);
     DrawTextureEx(tex_container, pos, 0.0, 6.0, colorset[i+1]);
                    }

 // Next, check containers for filled pixels and map to moai texture
 //
 for(k=0; k<3; k++) {
     start_bx = (FIELD_X / 4) * (k+1) - 6;

     // Holy shit, this looks AIDS-infested. Fuck math.
     //
     for(i=0; i<27; i++) {
         for(j=0; j<15; j++) {
             if(pixel_field[start_by + i][start_bx + j]) {
                 pos.x = (((FIELD_X / 4) * 6) * (k+1)) - (6 * 6) + (j * 6);
                 pos.y = start_y + (FIELD_Y * 6) - (28 * 6) + (i * 6);
                 tex_blit_c(tex_moai, (k*15)+j, i, pos.x, pos.y, 1, 1, 6.0, WHITE);
                                                         }
                             }
                         }
                    }

 return;
}




void draw_sky()
{
 Vector2 pos      = { -1000, -1000 };

 DrawTextureEx(tex_stars, pos, 0.0, 3.0, WHITE);

 tex_blit(tex_clouds, anims[10], 0, 0, SCREEN_H - 256, SCREEN_W, 256, 0.0, 2.0, Fade(WHITE, 0.75));

 if(flags.covered > 180) { draw_warning(); }

 return;
}




// NOTE: Draws warning on screen if all containers have been covered
//
void draw_warning()
{
 char blergh[80];

 tex_blit(tex_stripes, anims[8], 0, 0, 232, SCREEN_W, 32, 0.0, 2.0, Fade(ORANGE, 0.75));
 justify_text("W  A  R  N  I  N  G", 208, font1, WHITE, 3.0, 3.0);

 sprintf(blergh, "%d", flags.covered_countdown);
 justify_text(blergh, 130, font1, Fade(YELLOW, 0.50), 12.0, 12.0);


 return;
}



void fire_shot(float x, float y, float z, int direction)
{
 float off_z = 0;

 spawn_radiance(x, y, z + off_z, direction ^ 1);


 SetSoundVolume(sfx[82], scale(flags.rapid_fire, 0, 12, 0.20, 0.10));
 PlaySound(sfx[82]);

 if(flags.rapid_fire < 12) { flags.rapid_fire++; }
 return;
}




void destroy_enemy(int target, int attacker)
{
 int i       = 0;
 float pitch = 0.0;
 Vector3 pos = { 0 };

 if(!valid_actor(target))   { return; }
 if(!valid_actor(attacker)) { return; }

 pos.x = actors[target].pos.x;
 pos.y = actors[target].pos.y;
 pos.z = actors[target].pos.z;

 // Disable attacker and target
 //
 actors[attacker].inert   = 1;
 actors[attacker].stamina = 0;
 actors[target].stamina   = 0;
 actors[target].state     = 1;
 actors[target].team      = 6;

 switch(actors[target].cel_x) {
     case 5: // YO! block
             PlaySound(sfx[80]);
             flags.sum_yos++;
             for(i=0; i<400; i++) { spawn_antimatter(target); }
             break;

    case 13: // Brown Bomber
             PlaySound(sfx[17]);
             for(i=0; i<400; i++) { spawn_dirt(target); }
             break;

    default:
             pitch = 0.75 + (float)((float)quick_rand(50) / 100.0);
             set_sound(10, pitch, -1.0);
             PlaySound(sfx[10]);
             flags.sum_hits++;
             flags.score_diff += 75;

             for(i=0; i<5; i++) { spawn_debris(attacker, target); }
             for(i=0; i<60; i++) { spawn_pixel(target); }
             break;
                              }

 return;
}




int spawn_radiance(float x, float y, float z, bool dir)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 3, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].team    = 1;
     actors[who].scale   = 4.0;
     actors[who].effect  = 3;     // Additive blur
     actors[who].y_shift = 3;
     actors[who].state   = 5;
     actors[who].flicker = 0;
     actors[who].v_speed = 21.0;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 55;
     actors[who].preference = dir;
     actors[who].color   = WHITE;

     if(dir) { // Right shot
         actors[who].v_angle = 90.0;
             }
     else {    // Left shot
         actors[who].v_angle = 270.0;
         actors[who].flip = 1;
          }

     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: [FRAME] = 0 = BLUE
//                 1 = RED
//                 2 = GREEN
//                 3 = WHITE
//
int spawn_enemy(float x, float y, float z, int color, int direction, float wave_offset, int variety)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 6 + variety, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     if(!direction) { actors[who].v_angle = 270; }
     else           { actors[who].v_angle = 90;  actors[who].flip = 1; }

     actors[who].v_speed = 4.0;
     actors[who].last_angle = wave_offset;
     actors[who].path.y  = y;

     actors[who].team    = 2;
     actors[who].scale   = 3.0;
     actors[who].state   = 6;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = z;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;

     actors[who].color      = colorset[variety];
     actors[who].preference = direction;
     actors[who].extra[0]   = variety;

     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: [WHO] is the enemy getting blasted into bits
//
int spawn_debris(int attacker, int victim)
{
 int who = -1;

 if(!valid_actor(victim)) { return(-1); }

 who = spawn_actor(0, 0, 0, 0, 6, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     if(actors[attacker].preference) { actors[who].v_angle = 90  - 30 + quick_rand(60); }
     else                            { actors[who].v_angle = 270 - 30 + quick_rand(60); }

     actors[who].roll    = -4.0 + quick_rand(8);
     actors[who].v_speed = 5.0 + quick_rand(3);

     actors[who].team    = 6;
     actors[who].scale   = 3.0;
     actors[who].state   = 12;
     actors[who].pos.x   = actors[victim].pos.x;
     actors[who].pos.y   = actors[victim].pos.y;
     actors[who].pos.z   = actors[victim].pos.z;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 180;

     actors[who].color      = colorset[actors[victim].extra[0]];
     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_yo_block()
{
 int who = -1;
 int pos_y = 100 + quick_rand(300);
 int pos_x = 0;
 int direction = quick_rand(2);

 if(!direction) { pos_x = SCREEN_W + 50; }
 else           { pos_x = -50;           }

 who = spawn_actor(0, pos_x, pos_y, 0, 5, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     if(!direction) { actors[who].v_angle = 270; }
     else           { actors[who].v_angle = 90;  }

     actors[who].v_speed = 3.0;
     actors[who].last_angle = 0.0;
     actors[who].path.y  = pos_y;

     actors[who].team    = 2;
     actors[who].scale   = 3.0;
     actors[who].state   = 9;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;

     actors[who].color      = WHITE;
     actors[who].preference = direction;

     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_brown_bomber_block()
{
 int who = -1;
 int pos_y = 100 + quick_rand(300);
 int pos_x = 0;
 int direction = quick_rand(2);

 if(!direction) { pos_x = SCREEN_W + 50; }
 else           { pos_x = -50;           }

 who = spawn_actor(0, pos_x, pos_y, 0, 13, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     if(!direction) { actors[who].v_angle = 270; }
     else           { actors[who].v_angle = 90;  }

     actors[who].v_speed = 2.0;
     actors[who].last_angle = 0.0;
     actors[who].path.y  = pos_y;

     actors[who].team    = 2;
     actors[who].scale   = 3.0;
     actors[who].state   = 13;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].effect  = 30;     // Flickering aura
     actors[who].color      = WHITE;
     actors[who].preference = direction;

     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_pixel(int source_actor)
{
 int who = -1;
 int radius = 40;

 if(!valid_actor(source_actor)) { return(-1); }

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].v_angle = 170 + quick_rand(20);
     //actors[who].v_speed = 6.0;
     actors[who].v_speed = 4.0 + (float)((float)quick_rand(200) / 100.0);
     actors[who].team    = 5;
     actors[who].scale   = 3.0;
     actors[who].state   = 7;
     actors[who].pos.x   = actors[source_actor].pos.x - radius + (quick_rand(radius * 2));
     actors[who].pos.y   = actors[source_actor].pos.y - radius + (quick_rand(radius * 2)) - 48;
     actors[who].pos.z   = 0;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 600;
     actors[who].extra[0] = actors[source_actor].extra[0];
     actors[who].color    = colorset[actors[who].extra[0]];
     actors[who].effect  = 20;
     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_antimatter(int source_actor)
{
 int who = -1;
 int radius = 40;

 if(!valid_actor(source_actor)) { return(-1); }

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].v_angle = 145 + quick_rand(70);
     actors[who].v_speed = 6.0;
     actors[who].team    = 5;
     actors[who].scale   = 3.0;
     actors[who].state   = 8;
     actors[who].pos.x   = actors[source_actor].pos.x - radius + (quick_rand(radius * 2));
     actors[who].pos.y   = actors[source_actor].pos.y - radius + (quick_rand(radius * 2)) - 48;
     actors[who].pos.z   = 0;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 240;
     actors[who].color   = WHITE;
     actors[who].effect  = 21;
     actors[who].enabled = 1;
               }

 return(who);
}





int spawn_dirt(int source_actor)
{
 int who = -1;
 int radius = 40;

 if(!valid_actor(source_actor)) { return(-1); }

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].v_angle = 170 + quick_rand(20);
     actors[who].v_speed = 3.0 + (float)((float)quick_rand(300) / 100.0);
     actors[who].team    = 5;
     actors[who].scale   = 3.0;
     actors[who].state   = 7;
     actors[who].pos.x   = actors[source_actor].pos.x - radius + (quick_rand(radius * 2));
     actors[who].pos.y   = actors[source_actor].pos.y - radius + (quick_rand(radius * 2)) - 48;
     actors[who].pos.z   = 0;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 700;
     actors[who].extra[0] = 4; /// Dirt
     actors[who].color   = BROWN;
     actors[who].effect  = 20;
     actors[who].enabled = 1;
               }

 return(who);
}





// NOTE: Loops through pixel field list like a bitmap, and draws it
void draw_pixel_field()
{
 int i = 0;
 int j = 0;
 int start_y = SCREEN_H - (FIELD_Y * 6);

 for(i=0; i<FIELD_Y; i++) {
     for(j=0; j<FIELD_X; j++) {
         if(pixel_field[i][j]) {
             DrawRectangle(j * 6, start_y + (i * 6), 6, 6, colorset[pixel_field[i][j]]);
                               }
                              }
                          }


 /// DEBUG
 /// Draw game over section
 if(flags.debug) {
     int pos_x   = 0;
     int pos_y   = 0;
     int k = 0;
     for(i=0; i<3; i++) {
         pos_x = ((((FIELD_X / 4) * 6) * (i+1))) / 6;
         pos_x++;
         pos_y = FIELD_Y - 37;

         // Upper "roof" barriers (allows non-permeable sand to slide off)
         //
         for(k=0; k<9; k++) {
             DrawRectangle((pos_x-k) * 6, start_y + ((pos_y+k) * 6), 6, 6, Fade(PINK, 0.50));
             DrawRectangle((pos_x+k) * 6, start_y + ((pos_y+k) * 6), 6, 6, Fade(PINK, 0.50));
                            }
                        }
                 }

 return;
}




// NOTE: Checks pixel actor position against pixel field and reports
//       collision. 1 = collision
//
bool field_collision(int who)
{
 int pos_x    = 0;
 int pos_y    = 0;
 int p        = 0;
 int start_y  = SCREEN_H - (FIELD_Y * 6);

 if(!valid_actor(who)) { return(0); }

 int value = actors[who].extra[0];

 // Permeable value
 //
 p = value;
 pos_x = actors[who].pos.x / 6;
 pos_y = (actors[who].pos.y - start_y) / 6;


 // Reject pixels that are OOB
 //
 if(pos_x < 0 || pos_x >= FIELD_X) { kill_actor(who); return(0); }
 if(pos_y >= FIELD_Y)              { kill_actor(who); return(0); }
 if(pos_y < 0) { return(0); }


 // Check collision with bedrock first (simplifies checks below)
 //
 if(pos_y == (FIELD_Y - 1)) {
     pixel_field[pos_y][pos_x] = value;
     return(1);
                            }

 // If space we are in is occupied, check space above
 // and if that's clear, assign it. Otherwise let it die
 //
 if(pos_y > 0) {
     if(!is_clear(pos_x, pos_y, p)) {
         if(is_clear(pos_x, pos_y-1, p)) {
             pixel_field[pos_y-1][pos_x] = value;
                                         }
         return(1);
                                    }
               }

 // Check collision directly below
 //
 if(!is_clear(pos_x, pos_y+1, p)) {
     pixel_field[pos_y][pos_x] = value;
     return(1);
                                  }

 // check collision on side and diagonal
 //
 if(pos_x > 0) {
     if(!is_clear(pos_x-1, pos_y, p)) {
         pixel_field[pos_y][pos_x] = value;
         return(1);
                                      }

     if(!is_clear(pos_x-1, pos_y+1, p)) {
         pixel_field[pos_y][pos_x] = value;
         return(1);
                                        }
               }

 // check collision on side
 //
 if(pos_x < (FIELD_X-1)) {
     if(!is_clear(pos_x+1, pos_y, p)) {
         pixel_field[pos_y][pos_x] = value;
         return(1);
                                      }

     if(!is_clear(pos_x+1, pos_y+1, p)) {
         pixel_field[pos_y][pos_x] = value;
         return(1);
                                        }
                         }

 return(0);
}



// Simplified version of above with different action on contact
//
bool antimatter_collision(int who)
{
 int pos_x    = 0;
 int pos_y    = 0;
 int start_y  = SCREEN_H - (FIELD_Y * 6);

 if(!valid_actor(who)) { return(0); }

 pos_x = actors[who].pos.x / 6;
 pos_y = (actors[who].pos.y - start_y) / 6;


 // Reject pixels that are OOB
 //
 if(pos_x < 0 || pos_x >= FIELD_X) { kill_actor(who); return(0); }
 if(pos_y >= FIELD_Y)              { kill_actor(who); return(0); }
 if(pos_y < 0) { return(0); }


 // Antimatter collisions are not valid inside containers
 // BUT... if we are on top of the container, it's all good in the hood
 //
 if(barrier_field[pos_y][pos_x] && pos_y > (FIELD_Y - 29)) { return(1); }


 // Check collision with bedrock first (simplifies checks below)
 //
 if(pos_y == (FIELD_Y - 1)) {
     clear_field(pos_x, pos_y, 3, 3, 1);
     return(1);
                            }


 // Check collision directly below
 //
 if(pixel_field[pos_y+1][pos_x]) {
     clear_field(pos_x, pos_y+1, 3, 3, 1);
     return(1);
                                 }


 return(0);
}





// NOTE: Field is low resolution (171x100)
//       Motion seems good with a default 60Hz update rate
//       This allows particles to advance 1 "PIX" per cycle
//
void update_field()
{
 int i      = 0;
 int j      = 0;
 int p      = 0;
 int rand   = 0;
 int rand_2 = 0;


 // Loop through list in reverse Y order (ground-up)
 // If sand has an opportunity to move, let it move
 //
 for(i=FIELD_Y-2; i>=0; i--) {

     rand = quick_rand(100);
     if(is_odd(rand)) {
         for(j=0; j<FIELD_X; j++) {
             p = pixel_field[i][j];

             rand_2 = quick_rand(100);
             if(is_odd(rand)) { update_right_first(j, i, p); }
             else             { update_left_first(j, i, p);  }
                                  }
                      }

     else {
         for(j=FIELD_X-1; j>=0; j--) {
             p = pixel_field[i][j];

             rand_2 = quick_rand(100);
             if(is_odd(rand)) { update_right_first(j, i, p); }
             else             { update_left_first(j, i, p);  }
                                     }
          }
                             }

 return;
}




// Advances sand particles, left shift priority
//
void update_left_first(int x, int y, int p)
{
 bool moved = 0;

 if(pixel_field[y][x] > 0) {
     if(is_clear(x, y+1, p)) {
         pixel_field[y+1][x] = pixel_field[y][x];
         pixel_field[y][x] = 0;
                             }
     else {
         if(x < FIELD_X-1) {
             if(!is_clear(x,y+1,p) &&
                 is_clear(x+1, y+1, p)) {
                 pixel_field[y+1][x+1] = pixel_field[y][x];
                 pixel_field[y][x] = 0;
                 moved = 1;
                                        }
                                     }

         if(x > 0 && !moved) {
             if(!is_clear(x, y+1, p) &&
                is_clear(x-1, y+1, p)) {
                 pixel_field[y+1][x-1] = pixel_field[y][x];
                 pixel_field[y][x] = 0;
                                       }
                   }

          }
                           }

 return;
}




// Advances sand particles, right shift priority
//
void update_right_first(int x, int y, int p)
{
 bool moved = 0;

 if(pixel_field[y][x] > 0) {
     if(is_clear(x, y+1, p)) {
         pixel_field[y+1][x] = pixel_field[y][x];
         pixel_field[y][x] = 0;
                             }
     else {
         if(x > 0) {
             if(!is_clear(x, y+1, p) &&
                is_clear(x-1, y+1, p)) {
                 pixel_field[y+1][x-1] = pixel_field[y][x];
                 pixel_field[y][x] = 0;
                 moved = 1;
                                       }
                   }

         if(x < FIELD_X-1 && !moved) {
             if(!is_clear(x,y+1,p) &&
                 is_clear(x+1, y+1, p)) {
                 pixel_field[y+1][x+1] = pixel_field[y][x];
                 pixel_field[y][x] = 0;
                                        }
                                     }

          }
                           }

 return;
}





bool is_clear(int x, int y, int permeable)
{
 if(pixel_field[y][x] == 0 &&
    (!barrier_field[y][x] || barrier_field[y][x] == permeable)) { return(1); }

 return(0);
}





void spawn_wave()
{
 int i = 0;
 int who = -1;
 Vector3 pos = { 0 };

 int side = quick_rand(2);
 int length = 2 + quick_rand(5);
 int variety = 1 + quick_rand(3);

 pos.y = 100.0 + (float)quick_rand(400);
 pos.x = 0.0;

 for(i=0; i<length; i++) {
     if(!side) {
         pos.x = SCREEN_W + 50 + (100 * i);
               }
     else {
         pos.x = -50 - (100 * i);
          }
     who = spawn_enemy(pos.x, pos.y, pos.z, 0, side, (float)(30.0 * i), variety);
                         }

 return;
}




// NOTE: If [PROTECT_FILLING] is specified, pixels within a container
//       will not be cleared.
//
void clear_field(int x, int y, int w, int h, bool protect_filling)
{
 int i       = 0;
 int j       = 0;
 int pos_x   = 0;
 int pos_y   = 0;
 int start_x = x - (w/2);
 int start_y = y - (h/2);

 for(i=0; i<h; i++) {
     pos_y = start_y + i;
     if(pos_y >= 0 && pos_y < FIELD_Y) {
         for(j=0; j<w; j++) {
             pos_x = start_x + j;
             if(pos_x >= 0 && pos_x < FIELD_X) {
                 if(protect_filling) {
                     if(!barrier_field[pos_y][pos_x] || pos_y <= (FIELD_Y - 29)) { pixel_field[pos_y][pos_x] = 0; }
                                     }
                 else { pixel_field[pos_y][pos_x] = 0; }
                                               }
                            }
                                       }
                    }

 return;
}




void mark_field_containers()
{
 int i = 0;
 int j = 0;
 int k = 0;
 int pos_x   = 0;
 int pos_y   = 0;

 // I could do this procedurally, but I'm feeling *very* lazy right now
 //
 for(i=0; i<3; i++) {
     pos_x = ((((FIELD_X / 4) * 6) * (i+1)) - (7 * 6)) / 6;
     pos_y = FIELD_Y - 29;

     // Inner "Block" barrier (permeable)
     //
     for(k=0; k<27; k++) {
         for(j=0; j<15; j++) { barrier_field[pos_y+1+k][pos_x+1+j] = 1+i; } // Top
                         }

     // Wall barriers
     //
     for(j=0; j<17; j++) { barrier_field[pos_y+28][pos_x+j]   = 10; }   // Bottom
     for(j=0; j<27; j++) { barrier_field[pos_y+1+j][pos_x]    = 10; }   // Left side
     for(j=0; j<27; j++) { barrier_field[pos_y+1+j][pos_x+16] = 10; }   // Right side


     // Upper "roof" barriers (allows non-permeable sand to slide off)
     //
     for(k=1; k<9; k++) {
         for(j=0; j<17-(k*2); j++) { barrier_field[pos_y-(k-1)][pos_x+k+j] = 1+i; }
                        }
                    }

 return;
}



// NOTE: TESTING ONLY
//
void TEST_fill_container(int which)
{
 int i = 0;
 int j = 0;
 int k = 0;
 int start_bx = 0;
 int start_by = 0;

// int _fill[3] = { 2,3,1 }; // FILLS SCREEN
 int _fill[3] = { 1,3,2 };   // LAUNCH BLUE SIDE

 k = which;
 start_bx = (FIELD_X / 4) * (k+1) - 6;

     for(i=0; i<27; i++) {
         for(j=0; j<15; j++) {
             pixel_field[start_by + i][start_bx + j] = _fill[which];
                             }
                         }

 return;
}



bool is_container_full(int container)
{
 int i = 0;
 int j = 0;
 int k = 0;
 int start_bx = 0;
 int start_by = FIELD_Y - 28;

 // Sanity check
 //
 if(container < 0 || container > 2) { return(0); }

 k = container;
 start_bx = (FIELD_X / 4) * (k+1) - 6;

 for(i=0; i<27; i++) {
     for(j=0; j<15; j++) {
         if(!pixel_field[start_by + i][start_bx + j]) { return(0); }
                         }
                     }

 return(1);
}





void launch_moai(int container)
{
 int i = 0;
 int j = 0;
 int k = 0;
 int start_bx = 0;
 int start_by = FIELD_Y - 28;

 // Sanity check
 //
 if(container < 0 || container > 2) { return; }

 k = container;
 start_bx = (FIELD_X / 4) * (k+1) - 6;

 for(i=0; i<27; i++) {
     for(j=0; j<15; j++) { pixel_field[start_by + i][start_bx + j] = 0; }
                     }


 trigger_signal(1, 240, 0.1, 0.8);


 // Clear container and spawn moai actor
 //
 spawn_moai(container);

 return;
}





int spawn_moai(int container)
{
 int who   = -1;
 int flame = -1;
 int pos_x = (((FIELD_X / 4) * 6) * (container+1)) + 6;
 int pos_y = SCREEN_H - 9;

 who = spawn_actor(0, pos_x, pos_y, 0, container, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].path.y  = 0.1;
     actors[who].v_speed = 0.0;
     actors[who].team    = 10;
     actors[who].scale   = 6.0;
     actors[who].state   = 11;
     actors[who].cel     = tex_moai;
     actors[who]._size_w = 15;
     actors[who]._size_h = 27;
     actors[who].stamina = 260;
     actors[who].color   = WHITE;
     actors[who].extra[0] = container + 1;
     actors[who].enabled = 1;
               }

 flame = spawn_rocket_flame(who);
 if(flame != -1) { assign_animation(flame, 1, INFINITE); }

 flame = spawn_rocket_flame(who);
 if(flame != -1) {
     assign_animation(flame, 2, INFINITE);
     actors[flame].color = YELLOW;
                 }

 PlaySound(sfx[15]);

 return(who);
}





int spawn_rocket_flame(int moai)
{
 int who   = -1;

 who = spawn_actor(0, 0, 0, 0, 10, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].following = moai;
     actors[who].follow_x  = 0;
     actors[who].follow_y  = 99;
     actors[who].v_speed = 0.0;
     actors[who].team    = 12;
     actors[who].scale   = 3.0;
     actors[who].state   = 99;
     actors[who].flicker = 1;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 200;
     actors[who].color   = ORANGE;
     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: Clears the entire field of colors that aren't in containers
//       This will check the actor population as of last frame,
//       and pick a pattern that doesn't exhaust our actor supply
//
void clear_field_color(int color)
{
 int i         = 0;
 int j         = 0;
 int total     = 0;
 int available = MAX_ACTORS - flags.total_actors;
 int pattern   = 4;
 float _ratio  = 1.0;


 // First pass determines how many particles are getting wipes
 //
 for(i=0; i<FIELD_Y; i++) {
     for(j=0; j<FIELD_X; j++) {
         if(pixel_field[i][j] == color) {
             if(!barrier_field[i][j] || i <= (FIELD_Y - 29)) { total++; }
                                        }
                              }
                          }

 // Now we determine the pattern to use (every pixel, every other, every 3x, etc)
 //
 _ratio = (float)total / (float)available;

 if(_ratio > 1.00) { pattern = 4; } // EVERY 4x4
 if(_ratio < 0.90) { pattern = 3; } // EVERY 3x3
 if(_ratio < 0.75) { pattern = 2; } // EVERY 2x2
 if(_ratio < 0.50) { pattern = 1; } // FULL


 for(i=0; i<FIELD_Y; i++) {
     for(j=0; j<FIELD_X; j++) {
         if(pixel_field[i][j] == color) {
             if(!barrier_field[i][j] || i <= (FIELD_Y - 29)) {
                 if(!(i % pattern) && !(j % pattern)) { spawn_remnant(j, i, color); }
                 pixel_field[i][j] = 0;
                 flags.score_diff += 10;
                                                             }
                                        }
                              }
                          }

 return;
}





// NOTE: Checks arch over all three containers. If all pixels are covered,
//       then the game is over (if a launch isn't occurring)
//
bool is_game_over()
{

 int i = 0;
 int j = 0;
 int k = 0;
 int pos_x   = 0;
 int pos_y   = 0;
 int counter = 0;

 for(i=0; i<3; i++) {
     pos_x = ((((FIELD_X / 4) * 6) * (i+1))) / 6;
     pos_x++;
     pos_y = FIELD_Y - 37;

     for(k=0; k<9; k++) {
         if(k) { if(pixel_field[pos_y+k][pos_x-k]) { counter++; } }
                 if(pixel_field[pos_y+k][pos_x+k]) { counter++; }
                        }
                    }

 if(flags.debug) { log("Detected = %d\n", counter); }

 if(counter >= 51) { return(1); }
 else              { return(0); }
}





void kill_player()
{

 flags.game_ending     = 1;

 flags.tint_col        = BLACK;
 flags.tint_str        = 0.0;
 flags.tint_velocity   = 0.01;

 flags.mosaic          = 0.0;
 flags.mosaic_velocity = 0.01;

 flags.game_speed      = 1.0;
 flags.game_velocity   = -0.0075;

 PlaySound(sfx[17]);
 PlaySound(sfx[83]);

 return;
}





// NOTE: Remnants of sand particles that were obliterated by a launch
//
int spawn_remnant(int f_x, int f_y, int color_set)
{
 int who     = -1;
 int start_y = SCREEN_H - (FIELD_Y * 6);

 if(f_x < 0 || f_x >= FIELD_X) { return(-1); }
 if(f_y < 0 || f_y >= FIELD_Y) { return(-1); }

 who = spawn_actor(0, 0, 0, 0, 6, 0.0, 0.0, 0.0, 0);

 if(who != -1) {
     actors[who].v_angle = -10 + quick_rand(20);
     actors[who].roll    = -4.0 + quick_rand(8);
     actors[who].v_speed = 2.0 + quick_rand(3);
     actors[who].blend   = 0.50;
     actors[who].team    = 6;
     actors[who].scale   = 3.0;
     actors[who].state   = 10;
     actors[who].pos.x   = f_x * 6.0;
     actors[who].pos.y   = start_y + (f_y * 6.0);
     actors[who].pos.z   = 0.0;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 240;

     actors[who].color   = colorset[color_set];
     actors[who].enabled = 1;
               }

 return(who);
}
